

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.Localisation &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Python programs and modules" href="index.html" />
    <link rel="next" title="pywws.calib" href="pywws.calib.html" />
    <link rel="prev" title="pywws.TimeZone" href="pywws.TimeZone.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.calib.html" title="pywws.calib"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pywws.TimeZone.html" title="pywws.TimeZone"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="module-pywws.Localisation">
<span id="pywws-localisation"></span><h1>pywws.Localisation<a class="headerlink" href="#module-pywws.Localisation" title="Permalink to this headline">¶</a></h1>
<p>Localisation.py - provide translations of strings into local
language</p>
<div class="highlight-python"><pre>usage: python pywws/Localisation.py [options]
options are:
 -h       or  --help       display this help
 -t code  or  --test code  test use of a language code</pre>
</div>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Some of the pywws modules, such as WindRose.py, can automatically use
your local language for such things as wind directions. The
Localisation.py module, mostly copied from examples in the Python
documentation, enables this.</p>
<p>Localisation of pywws is done in two parts - translating strings such
as &#8216;rising very rapidly&#8217;, and changing the &#8216;locale&#8217; which controls
things like month names and number representation (e.g. &#8216;23,2&#8217; instead
of &#8216;23.2&#8217;). On some computers it may not be possible to set the
locale, but translated strings can still be used.</p>
</div>
<div class="section" id="using-a-different-language">
<h2>Using a different language<a class="headerlink" href="#using-a-different-language" title="Permalink to this headline">¶</a></h2>
<p>The language used by pywws is set in the <tt class="docutils literal"><span class="pre">[config]</span></tt> section of the
<tt class="docutils literal"><span class="pre">weather.ini</span></tt> file. This can be a two-letter language code, such as
<tt class="docutils literal"><span class="pre">en</span></tt> (English), or can specify a national variant, such as <tt class="docutils literal"><span class="pre">fr_CA</span></tt>
(Canadian French). It could also include a character set, for example
<tt class="docutils literal"><span class="pre">de_DE.UTF-8</span></tt>.</p>
<p>The choice of language is very system dependant, so Localisation.py
can be run as a standalone program to test language codes. A good
starting point might be your system&#8217;s <tt class="docutils literal"><span class="pre">LANG</span></tt> environment variable,
for example:</p>
<div class="highlight-python"><pre>jim@brains:~/Documents/weather/devel$ echo $LANG
en_GB.UTF-8
jim@brains:~/Documents/weather/devel$ python pywws/Localisation.py -t en_GB.UTF-8
Locale changed from (None, None) to ('en_GB', 'UTF8')
Translation set OK
Locale
  decimal point: 23.2
  date &amp; time: Friday, 14 October (14/10/11 13:02:00)
Translations
  'NNW' =&gt; 'NNW'
  'rising very rapidly' =&gt; 'rising very rapidly'
  'Rain at times, very unsettled' =&gt; 'Rain at times, very unsettled'
jim@brains:~/Documents/weather/devel$</pre>
</div>
<p>In most cases no more than a two-letter code is required:</p>
<div class="highlight-python"><pre>jim@brains:~/Documents/weather/devel$ python pywws/Localisation.py -t fr
Locale changed from (None, None) to ('fr_FR', 'UTF8')
Translation set OK
Locale
  decimal point: 23,2
  date &amp; time: vendredi, 14 octobre (14/10/2011 13:04:44)
Translations
  'NNW' =&gt; 'NNO'
  'rising very rapidly' =&gt; 'en hausse très rapide'
  'Rain at times, very unsettled' =&gt; 'Quelques précipitations, très perturbé'
jim@brains:~/Documents/weather/devel$</pre>
</div>
<p>If you try an unsupported language, pywws falls back to English:</p>
<div class="highlight-python"><pre>jim@brains:~/Documents/weather/devel$ python pywws/Localisation.py -t ja
Failed to set locale: ja
No translation file found for: ja
Locale
  decimal point: 23.2
  date &amp; time: Friday, 14 October (10/14/11 13:08:49)
Translations
  'NNW' =&gt; 'NNW'
  'rising very rapidly' =&gt; 'rising very rapidly'
  'Rain at times, very unsettled' =&gt; 'Rain at times, very unsettled'
jim@brains:~/Documents/weather/devel$</pre>
</div>
<p>Once you&#8217;ve found a suitable language code that works, you can
configure pywws to use it by editing your <tt class="docutils literal"><span class="pre">weather.ini</span></tt> file:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="p">[</span><span class="n">config</span><span class="p">]</span>
<span class="n">language</span> <span class="o">=</span> <span class="n">fr</span>
</pre></div>
</div>
</div>
<div class="section" id="creating-a-new-translation">
<h2>Creating a new translation<a class="headerlink" href="#creating-a-new-translation" title="Permalink to this headline">¶</a></h2>
<p>If there is no translation file for your preferred language then you
need to create one. See <a class="reference internal" href="../guides/language.html"><em>How to make a language file for pywws</em></a> for detailed
instructions.</p>
<p class="rubric">Functions</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.Localisation.SetLocale" title="pywws.Localisation.SetLocale"><tt class="xref py py-obj docutils literal"><span class="pre">SetLocale</span></tt></a>(lang)</td>
<td>Set the &#8216;locale&#8217; used by a program.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.Localisation.SetTranslation" title="pywws.Localisation.SetTranslation"><tt class="xref py py-obj docutils literal"><span class="pre">SetTranslation</span></tt></a>(lang)</td>
<td>Set the translation used by (some) pywws modules.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.Localisation.SetApplicationLanguage" title="pywws.Localisation.SetApplicationLanguage"><tt class="xref py py-obj docutils literal"><span class="pre">SetApplicationLanguage</span></tt></a>(params)</td>
<td>Set the locale and translation for a pywws program.</td>
</tr>
</tbody>
</table>
<dl class="function">
<dt id="pywws.Localisation.SetLocale">
<tt class="descclassname">pywws.Localisation.</tt><tt class="descname">SetLocale</tt><big>(</big><em>lang</em><big>)</big><a class="reference internal" href="../_modules/pywws/Localisation.html#SetLocale"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Localisation.SetLocale" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the &#8216;locale&#8217; used by a program.</p>
<p>This affects the entire application, changing the way dates,
currencies and numbers are represented. It should not be called
from a library routine that may be used in another program.</p>
<p>The <tt class="docutils literal"><span class="pre">lang</span></tt> parameter can be any string that is recognised by
<tt class="docutils literal"><span class="pre">locale.setlocale()</span></tt>, for example <tt class="docutils literal"><span class="pre">en</span></tt>, <tt class="docutils literal"><span class="pre">en_GB</span></tt> or <tt class="docutils literal"><span class="pre">en_GB.UTF-8</span></tt>.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>lang</strong> (<em>string</em>) &#8211; language code.</li>
</ul>
</td>
</tr>
<tr class="field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">success status.</p>
</td>
</tr>
<tr class="field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last">bool</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="pywws.Localisation.SetTranslation">
<tt class="descclassname">pywws.Localisation.</tt><tt class="descname">SetTranslation</tt><big>(</big><em>lang</em><big>)</big><a class="reference internal" href="../_modules/pywws/Localisation.html#SetTranslation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Localisation.SetTranslation" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the translation used by (some) pywws modules.</p>
<p>This sets the translation object <tt class="docutils literal"><span class="pre">Localisation.translation</span></tt> to
use a particular language.</p>
<p>The <tt class="docutils literal"><span class="pre">lang</span></tt> parameter can be any string of the form <tt class="docutils literal"><span class="pre">en</span></tt>,
<tt class="docutils literal"><span class="pre">en_GB</span></tt> or <tt class="docutils literal"><span class="pre">en_GB.UTF-8</span></tt>. Anything after a <tt class="docutils literal"><span class="pre">.</span></tt> character is
ignored. In the case of a string such as <tt class="docutils literal"><span class="pre">en_GB</span></tt>, the routine
will search for an <tt class="docutils literal"><span class="pre">en_GB</span></tt> language file before searching for an
<tt class="docutils literal"><span class="pre">en</span></tt> one.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>lang</strong> (<em>string</em>) &#8211; language code.</li>
</ul>
</td>
</tr>
<tr class="field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">success status.</p>
</td>
</tr>
<tr class="field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last">bool</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="pywws.Localisation.SetApplicationLanguage">
<tt class="descclassname">pywws.Localisation.</tt><tt class="descname">SetApplicationLanguage</tt><big>(</big><em>params</em><big>)</big><a class="reference internal" href="../_modules/pywws/Localisation.html#SetApplicationLanguage"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Localisation.SetApplicationLanguage" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the locale and translation for a pywws program.</p>
<p>This function reads the language from the configuration file, then
calls <a class="reference internal" href="#pywws.Localisation.SetLocale" title="pywws.Localisation.SetLocale"><tt class="xref py py-func docutils literal"><span class="pre">SetLocale()</span></tt></a> and <a class="reference internal" href="#pywws.Localisation.SetTranslation" title="pywws.Localisation.SetTranslation"><tt class="xref py py-func docutils literal"><span class="pre">SetTranslation()</span></tt></a>.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>params</strong> (<em>object</em>) &#8211; a <a class="reference internal" href="pywws.DataStore.html#pywws.DataStore.params" title="pywws.DataStore.params"><tt class="xref py py-class docutils literal"><span class="pre">pywws.DataStore.params</span></tt></a> object.</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="pywws.Localisation.main">
<tt class="descclassname">pywws.Localisation.</tt><tt class="descname">main</tt><big>(</big><em>argv=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/Localisation.html#main"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Localisation.main" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">pywws.Localisation</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#using-a-different-language">Using a different language</a></li>
<li><a class="reference internal" href="#creating-a-new-translation">Creating a new translation</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="pywws.TimeZone.html"
                        title="previous chapter">pywws.TimeZone</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pywws.calib.html"
                        title="next chapter">pywws.calib</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.calib.html" title="pywws.calib"
             >next</a> |</li>
        <li class="right" >
          <a href="pywws.TimeZone.html" title="pywws.TimeZone"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>